﻿#pragma warning(disable : 4996)
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <queue>
#include <list>
#include <stack>
#include <fstream>
#include <sstream>
#include <functional>
#include <climits>

#define all(t) t.begin(), t.end()
#define ll long long
#define ull unsigned long long
#define ld long double
#define ainb(a, b) (b.find(a) != b.end())
#define vll vector<ll>
#define vec vector
#define cll(cll_i) ll cll_i; cin >> cll_i;
#define pll pair<ll, ll>
#define vpl vec<pll>
#define invll(invec_v, invec_n) vll invec_v(invec_n); for (ll &invec_i : invec_v) cin >> invec_i;
#define outvec(outvec_v) for (auto &outvec_i : outvec_v) cout << outvec_i << " "; cout << '\n';
#define sqr(x) (x) * (x)
#define FOR(FOR_I, FOR_END) for (ll FOR_I = 0; FOR_I < FOR_END; FOR_I++)
#define FE(FOR_I, ITERABLE) for (auto &FOR_I : ITERABLE)
#define FEC(FOR_I, ITERABLE) for (const auto &FOR_I : ITERABLE)
using namespace std;

struct HP
{
    ll h;
    ll p;

    bool operator<(const HP& other) const
    {
        return make_pair(p, p - h) < make_pair(other.p, other.p - other.h);
    }
};

void solve()
{
    cll(n);

    invll(hs, n);
    invll(ps, n);
    vec<HP> hps(n);
    for (ll i = 0; i < n; i++)
    {
        hps[i].h = hs[i];
        hps[i].p = ps[i];
    }

    sort(all(hps));

    for (ll i = 0; i < n - 1; i++)
    {
        if (hps[i].p == hps[i + 1].p && hps[i].h != hps[i + 1].h)
        {
            cout << -1 << '\n';
            return;
        }
    }

    ll prev_d = -1e9;
    for (ll i = 0; i < n; i++)
    {
        ll d = hps[i].p - hps[i].h;
        if (d < prev_d)
        {
            cout << -1 << '\n';
            return;
        }
        prev_d = d;
    }

    ll prev_h = -1e9;
    for (ll i = 0; i < n; i++)
    {
        if (hps[i].h < prev_h)
        {
            cout << -1 << '\n';
            return;
        }
        prev_h = hps[i].h;
    }

    ll mxm_d = 0;
    for (ll i = 0; i < n; i++)
    {
        ll d = hps[i].p - hps[i].h;
        if (d < 0)
        {
            cout << -1 << '\n';
            return;
        }
        mxm_d = max(mxm_d, d);
    }
    cout << mxm_d << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG

    ll t = 1;
    cin >> t;
    while (t--) solve();

    return 0;
}
