#include<bits/stdc++.h>

using namespace std;

void IOSync() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
}

int countChar(std::vector<string> &str, int n, int chr) {
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (size_t j = 0; j < str[i].size(); ++j) {
            if (str[i][j] - 'a' != chr) {
                break;
            }
            cnt += 1;
        }
    }
    return cnt;
}

void solve() {
    int n, e;
    std::cin >> n >> e;
    std::vector<bool> sp(e, false);
    std::vector<string> str(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> str[i];
        bool fl = true;
        for (size_t j = 1; j < str[i].size(); ++j) {
            fl &= (str[i][j] == str[i][0]);
        }
        sp[str[i][0] - 'a'] = sp[str[i][0] - 'a'] | fl;
    }
    int ans = -1;
    for (int i = 0; i < e; ++i) {
        if (!sp[i]) {
            if (ans == -1 || countChar(str, n, ans) > countChar(str, n, i)) {
                ans = i;
            }
        }
    }
    if (ans == -1) {
        std::cout << "NO";
        return;
    }
    for (int i = 0; i <= countChar(str, n, ans); ++i) {
        std::cout << char('a' + ans);
    }
    return;
}

int32_t main() {
    IOSync();
    int tests = 1;
    // std::cin >> tests;
    while(tests--) {
        solve();
    }
    return 0;
}
