def solve(n, h, p):
    indices = [i for i in range(n)]
    indices.sort(key=lambda i: (h[i], p[i]))
    prev_diff = -1
    max_diff = 0
    for i in indices:
        diff = p[i] - h[i]
        if diff < 0 or prev_diff > diff:
            return -1
        prev_diff = diff
        max_diff = max(max_diff, diff)
    return max_diff


t = int(input())
for _ in range(t):
    n = int(input())
    h = list(map(int, input().split()))
    p = list(map(int, input().split()))
    print(solve(n, h, p))
