from collections import namedtuple

mnt = namedtuple('mnt', ['height', 'diff'])


def solve():
    n = int(input())
    h = list(map(int, input().split()))
    p = list(map(int, input().split()))

    mnts = []
    for i in range(n):
        mnts.append(mnt(p[i], p[i] - h[i]))
        if p[i] - h[i] < 0:
            return -1

    mnts.sort(key=lambda mnt: (mnt.height, mnt.diff), reverse=True)

    if any(mnts[i].height == mnts[i + 1].height and mnts[i].diff != mnts[i + 1].diff for i in range(n - 1)):
        return -1

    if all(mnts[i].diff >= mnts[i + 1].diff for i in range(n - 1)):
        return mnts[0].diff

    return -1


t = int(input())

answer = []
for _ in range(t):
    ans = solve()
    answer.append(ans)

print('\n'.join(map(str, answer)))

"""
4
4
3 2 4 2
5 3 6 2
1
10
100000
5
1 2 3 4 5
1 2 3 4 5
3
1 4 6
4 1 8
"""

"""
1
3
1 0 1
1 1 2
"""
