#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#ifdef LOCAL
    #define debug(x) cout << (#x) << ": " << (x) << "\n";
#else
    #define debug(x);
#endif

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> deg(n);
    vector<vector<ll>> g(n);
    vector<vector<ll>> g2(n);
    vector<bool> used(n);
    for (int i = 0; i < m; ++i) {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        deg[u]++;
        deg[v]--;
        g[u].push_back(v);
        g2[v].push_back(u);
    }

    set<ll> goodVer;
    vector<ll> res;
    ll k = 0;

    for (int i = 0; i < n; ++i) {
        if (deg[i] >= 0) {
            goodVer.insert(i);
        }
    }

    while (!goodVer.empty()) {
        k++;
        ll v = *goodVer.begin();
        res.push_back(v + 1);
        goodVer.erase(goodVer.begin());
        used[v] = true;
        for (auto u : g[v]) {
            if (!used[u]) {
                deg[u]++;
                if (deg[u] == 0) {
                    goodVer.insert(u);
                }
            }
        }

        for (auto u : g2[v]) {
            if (!used[u]) {
                deg[u]--;
                if (deg[u] == -1) {
                    goodVer.erase(goodVer.find(u));
                }
            }
        }
    }

    if (k == n) {
        for (auto r : res) cout << r << " ";
        cout << "\n";
    } else {
        cout << -1 << "\n";
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
