#include<bits/stdc++.h>

using namespace std;

#define int long long
int const maxn = 1e5 + 5;
int x[maxn], y[maxn], mod = 998244353;
int st[maxn];

int get(vector < int > a) {
    int ans = 0, n = a.size(), flag = 0;
    for (int i = n - 1; i >= 0; i--) {
        int dist = a[i];
        if (flag) dist = 2 - dist;
        ans = (ans + st[i] * dist) % mod;
        if (a[i] == 1) flag ^= 1;
    }
    return ans;
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    st[0] = 1;
    for (int i = 1; i < maxn; i++) st[i] = st[i - 1] * 3 % mod;
    while (t--) {
        int n;
        cin >> n;
        vector < int > a(n), b(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            a[i]--;
        }
        for (int i = 0; i < n; i++) {
            cin >> b[i];
            b[i]--;
        }
        while (a.size() > 0 && b.size() > 0 && a.back() == b.back()) {
            a.pop_back();
            b.pop_back();
        }
        if (a.empty()) cout << 0 << '\n';
        else {
            if (a.back() < b.back()) swap(a, b);
            cout << (get(a) - get(b) + mod) % mod << '\n';
        }
    }
    return 0;
}
