﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <string>
#include <set>
#include <map>
#include <queue>
#define ll long long
#define vll vector <ll>
#define f(i, n) for(int i = 0; i < n; i++)
#define pll pair <ll, ll>
#define mp(a, b) make_pair(a, b)
using namespace std;
ll timer = 1;
vll tout, answer;
vector <vector <ll>> g;
vll topsort;

vector <bool> used;

void dfs1(ll v, vector <vll> &g) {
    used[v] = true;
    for (auto it : g[v]) {
        if(!used[it])
            dfs1(it, g);
    }
    topsort.push_back(v);
    tout[v] = timer++;
}

void dfs2(ll v, vector <vll>& g) {
    used[v] = true;
    answer.push_back(v);
    for (auto it : g[v]) {
        if(!used[it])
            dfs2(it, g);
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    g.resize(n);
    tout.resize(n);
    used.resize(n);

    f(i, m) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
    }
    dfs1(0, g);
    
    sort(topsort.begin(), topsort.end(), [&](ll a, ll b) {
        return tout[a] > tout[b];
        });
   
    used.assign(n, false);
    for (auto v : topsort) {
        if (!used[v])
            dfs2(v, g);
    }
    for (auto it : answer) {
        cout << it + 1 << " ";
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}
