﻿//#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <stack>
#include <random>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <climits>
#include <tuple>


using namespace std;
using ll = long long;
using db = double;
using ldb = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vll = vector<ll>;
using vvll = vector<vector<ll>>;
using vint = vector<int>;
using vst = vector<string>;
#define all(x) x.begin(), x.end()
#define size(x) int(x.size())
#define forp(i,s,f) for(int i = s; i < f; ++i)
#define form(i,s,f) for(int i = s; i > f; --i)
#define dprint(x) for(auto now: x) cout << now << ' '

const int MOD = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int MOD3 = 998244353;
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;
const double EPS = 1e-9;
const double PI = acosl(-1.0);

void solve() {
    int n;
    cin >> n;
    vll sp(n);
    ll mn = LINF;
    int ind = 0;
    forp(i, 0, n) {
        cin >> sp[i];
        if (sp[i] < mn) {
            ind = i;
            mn = sp[i];
        }
    }
    if (n == 2) {
        ll a = sp[0];
        ll b = sp[1];
        forp(I, 0, 100) {
            if (a == b) break;
            if (a > b) swap(a, b);
            if (a < 0) break;
            ll tom = b - a;
            b -= 2 * tom;
            a -= tom;
        }
        cout << max(0ll, a) << '\n';
        return;
    }
    
    forp(I, 0, 100) {
        bool f = true;
        forp(i, 1, n) {
            if (sp[i] != sp[i - 1]) {
                f = false;
                break;
            }
        }
        if (f) {
            cout << max(0ll, sp[0]) << '\n';
            return;
        }
        forp(i, 1, n) {
            int prev = (ind - i + n) % n;
            int prev_prev = (prev - 1 + n) % n;
            ll val_prev = sp[prev];
            ll val_prev_prev = sp[prev_prev];
            ll now = sp[ind];
            if (val_prev > now) {
                ll to_minus = (val_prev - now + 1) / 2;
                sp[prev] -= to_minus * 2;
                sp[prev_prev] -= to_minus;
            }
            
        }
    }
    cout << "0\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(x);
    cout << fixed;
    int t;
    //t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
