﻿//#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <stack>
#include <random>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <climits>


using namespace std;
using ll = long long;
/*

using ld = long double;
using point = pair<ld, ld>;
#define x first
#define y second
using Vector2 = pair<point, point>;
#define x1 first.x
#define x2 second.x
#define y1 first.y
#define y2 second.y
*/
#define all(x) x.begin(), x.end()
#define size(x) int(x.size())
#define forp(i,s,f) for(int i = s; i < f; ++i)
#define form(i,s,f) for(int i = s; i > f; --i)
#define dprint(x) for(auto now: x) cout << x << ' '



const int MOD = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int MOD3 = 998244353;
const int INF = 2e9 + 7;
//const ll LINF = 1e18 + 7;

using Sphere = pair<pair<ll, ll>, ll>;
#define x first.first
#define y first.second
#define r second
vector<Sphere> v;
bool CheckS(ll i, ll j) {
    return (v[i].x - v[j].x) * (v[i].x - v[j].x) + (v[i].y - v[j].y) * (v[i].y - v[j].y)
        == (v[i].r + v[j].r) * (v[i].r + v[j].r);
}
int CheckS(Sphere i, Sphere j) {
    ll lef = (i.x - j.x) * (i.x - j.x) + (i.y - j.y) * (i.y - j.y);
    ll rig = (i.r + j.r) * (i.r + j.r);

    if (lef == rig)
        return 0;
    if (lef < rig)
        return -1;
    if (lef > rig)
        return 1;
    return (i.x - j.x) * (i.x - j.x) + (i.y - j.y) * (i.y - j.y)
        == (i.r + j.r) * (i.r + j.r);
}

int CheckSLine(Sphere i, Sphere j) {
    ll lef = abs(i.x - j.x) + abs(i.y - j.y);
    ll rig = (i.r + j.r);

    if (lef == rig)
        return 0;
    if (lef < rig)
        return -1;
    if (lef > rig)
        return 1;
}
int CheckSDiag(Sphere i, Sphere j) {
    if (CheckSLine(i, j) == 0) {
        return -1;
    }
    ll lef = (i.x - j.x) * (i.x - j.x) + (i.y - j.y) * (i.y - j.y);
    ll rig = (i.r + j.r) * (i.r + j.r);

    if (lef == rig)
        return 0;
    if (lef < rig)
        return -1;
    if (lef > rig)
        return 1;
    return (i.x - j.x) * (i.x - j.x) + (i.y - j.y) * (i.y - j.y)
        == (i.r + j.r) * (i.r + j.r);
}

int solve() {
    ll res = 0;
    ll n;
    cin >> n;
    v.clear();
    v.resize(n);

    map<ll, vector<Sphere>> poX, poY;
    map<pair<ll, ll>, vector<Sphere>> po34, po43;
    
    forp(i, 0, n) {
        cin >> v[i].x >> v[i].y >> v[i].r;
        v[i].x += 1000000000;
        v[i].y += 1000000000;

        Sphere newS = Sphere(pair<ll, ll>(v[i].x, v[i].y), v[i].r);
        poX[v[i].x].push_back(newS);
        poY[v[i].y].push_back(newS);
        po34[{v[i].x % 3, v[i].y % 4}].push_back(newS);
        po43[{v[i].x % 4, v[i].y % 3}].push_back(newS);

    }

    for (auto now : poX) {
        sort(all(now.second));

        forp(i, 1, size(now.second)) {
            int j = i - 1;
            while (j >= 0)
            {
                int check = CheckSLine(now.second[i], now.second[j]);
                if (check == 0) {
                    res++;
                }
                if (check == 1) {
                    break;
                }
                j--;
            }
        }
    }
    for (auto now : poY) {
        sort(all(now.second));

        forp(i, 0, size(now.second)) {
            //cout << now.second[i].x - 1000000000 << " ";
        }

        forp(i, 1, size(now.second)) {
            int j = i - 1;
            while (j >= 0)
            {
                int check = CheckSLine(now.second[i], now.second[j]);
                if (check == 0) {
                    res++;
                }
                if (check == 1) {
                    break;
                }
                j--;
            }
        }
    }
    for (auto now : po34) {
        sort(all(now.second));

        forp(i, 1, size(now.second)) {
            int j = i - 1;
            while (j >= 0)
            {
                int check = CheckSDiag(now.second[i], now.second[j]);
                if (check == 0) {
                    res++;
                }
                if (check == 1) {
                    break;
                }
                j--;
            }
        }
    }
    for (auto now : po43) {
        sort(all(now.second));

        forp(i, 1, size(now.second)) {
            int j = i - 1;
            while (j >= 0)
            {
                int check = CheckSDiag(now.second[i], now.second[j]);
                if (check == 0) {
                    res++;
                }
                if (check == 1) {
                    break;
                }
                j--;
            }
        }
    }

    return res;
}

vector<int> ans;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(x);
    cout << fixed;
    int t;
    //t = 1;
    cin >> t;
    ans.resize(t);
    int i;
    forp(i, 0, t) {
        ans[i] = solve();
    }
    forp(i, 0, t) {
        cout << ans[i] << "\n";
    }
}

/*
1
6
-3 0 3
-2 0 2
-1 0 1
1 0 1
2 0 2
3 0 3
*/