#include <bits/stdc++.h>
using namespace std;

vector< vector<int> > gr, rev_gr;
vector<int> cnt, col, used;
vector<int> topsort;

void dfs(int v) {
    used[v] = 1;
    for (int u: gr[v]) {
        if (!used[u]) dfs(u);
    }
    topsort.push_back(v);
}

void kss(int v, int c) {
    used[v] = c;
    for (int u: rev_gr[v]) {
        if (!used[u]) kss(u, c);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        int n, m;
        cin >> n >> m;
        gr.assign(n, vector<int>(0));
        rev_gr.assign(n, vector<int>(0));
        vector<pair<int,int> > edges;
        cnt.assign(n, 0);
        col.assign(n, 0);
        used.assign(n, 0);
        topsort.clear();
        for (int i = 0; i < m; i++) {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            gr[a].push_back(b);
            rev_gr[b].push_back(a);
            edges.push_back(pair<int,int>{a, b});
            cnt[a]++;
        }
//        set<pair<int,int> > st;
//        bool flag = false;
//        vector<int> res;
//        while (!flag) {
//            int mx = 0;
//            for (int i = 0; i < n; i++) {
//                if (!col[i]) mx = max(mx, cnt[i]);
//            }
//            for (int i = 0; i < n; i++) {
//                if (cnt[i] == mx && !col[i]) {
//                    st.insert(pair<int,int>{-cnt[i], i});
//                }
//            }
//            while (!st.empty()) {
//                pair<int,int> pp = *st.begin();
//                res.push_back(pp.second);
//                col[pp.second] = 1;
//                st.erase(st.begin());
//                for (int ver: gr[pp.second]) {
//                    if (!col[ver]) {
//                        st.insert(pair<int,int> {-cnt[ver], ver});
//                    }
//                }
//            }
//            flag = true;
//            for (int i = 0; i < n; i++) {
//                if (!col[i]) flag = false;
//            }
//        }
//        vector<int> ind(n);
//        for(int i = 0; i < n; i++) {
//            ind[res[i]] = i;
//        }
        for (int i = 0; i < n; i++) {
            if (!used[i]) dfs(i);
        }
        reverse(topsort.begin(), topsort.end());
        used.assign(n, 0);
        int cntr = 1;
        for (int i = 0; i < n; i++) {
            if (!used[topsort[i]]) {
                kss(topsort[i], cntr);
                cntr++;
            }
        }
        vector< vector<int> > vert_by_color(cntr);
        for (int i = 0; i < n; i++) vert_by_color[used[i]].push_back(i+1);
        vector< vector<pair<int,int> > > edges_by_color(cntr);
        for (pair<int,int> edge: edges) {
            if (used[edge.first] == used[edge.second]) {
                edges_by_color[used[edge.first]].push_back(edge);
            }
        }
        for (int u = 1; u < cntr; u++) {
            int cnt1 = 0, cnt2 = 0;
            for (pair<int,int> edge: edges) {
                int a = edge.first, b = edge.second;
                if (a < b) cnt1++;
                else cnt2++;
            }
            if (cnt1 >= cnt2) {
                for (int i = 0; i < (int)vert_by_color[u].size(); i++) cout << vert_by_color[u][i] << ' ';
            }
            else {
                for (int i = (int)vert_by_color[u].size() - 1; i >= 0; i--) cout << vert_by_color[u][i] << ' ';
            }
        }
        cout << '\n';
//        vector<int> ind(n);
//        for(int i = 0; i < n; i++) {
//            ind[topsort[i]] = i;
//        }
//        int cnt1 = 0, cnt2 = 0;
//        for (pair<int,int> edge: edges) {
//            int a = edge.first, b = edge.second;
//            if (ind[a] < ind[b]) cnt1++;
//            else cnt2++;
//        }
//        if (cnt2 > cnt1) {
//            for (int i = 0; i < 1e9; i++) {
//                for (int j = 0; j < 1e9; j++) {
//                    int k = i + j;
//                }
//            }
//        }
//        else {
//            for (int x: topsort) cout << x+1 << ' ';
//            cout << '\n';
//        }
    }
}
