﻿#include <iostream>
#include <map>
#include <vector>
#include <string>
#include <algorithm>
#include <fstream>
#include <set>
#include <queue>
#include <iomanip>
#include <deque>
#include <cmath>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <random>

#pragma GCC optimize("O3")
#pragma GCC target("avx2")


using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

mt19937 rnd(1046527);

void solve()
{
	ll n;
	cin >> n;
	vector<pair<ll, ll>> a(n);
	for (int i = 0; i < n; ++i) cin >> a[i].first;
	for (int i = 0; i < n; ++i) cin >> a[i].second;

	sort(a.begin(), a.end());
	ll cou = 0, ans = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i].second - a[i].first < cou) {
			ans = -1;
			break;
		}
		else {
			cou = a[i].second - a[i].first;
			ans = max(ans, cou);
		}
	}
	cout << ans << '\n';
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	cin >> t;
	++t;
	while (--t) solve();
}

