#include <iostream>
#include "bits/stdc++.h"

#include <unordered_set>
#define int long long
using namespace std;

map<int, unordered_set<int>> graph;
map<int, bool> used;
int aa = -1;

vector<int> dfs(int v, int aa = -1) {
    if (used[v]) {
        aa = v;
        return {};
    }
    if (aa != -1) {
        return {};
    }
    used[v] = true;
    vector<int> res;
    for (auto n : graph[v]) {
        for (auto a : dfs(n)) {
            res.push_back(a);
        }
        aa = -1;
    }
    return res;
}

struct tree {
    int n;
    vector<int> t;

    void init(int n) {
        this->n = n;
        t.resize(n * 4);
    }

    int merge(const int &a, const int &b) {
        return (a + b);
    }

    void build(const vector<int> &a) {
        build(1, 0, (this->n) - 1, a);
    }

    void build(int v, int l, int r, const vector<int> &a) {
        if (l == r) {
            t[v] = a[l];
            return;
        }
        int m = l + (r - l) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m + 1, r, a);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(const int &x, const int &pos) {
        update(1, 0, (this->n) - 1, x, pos);
    }

    void update(int v, int tl, int tr, const int &x, const int &pos) {
        if (tl == tr) {
            t[v] = x;
            return;
        }

        int tm = tl + (tr - tl) / 2;
        if (tl <= pos && pos <= tm) {
            update(v * 2, tl, tm, x, pos);
        } else if (tm < pos && pos <= tr) {
            update(v * 2 + 1, tm + 1, tr, x, pos);
        } else {
            cerr << "Error: " << pos << "is out of bound" << endl;
        }
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int l, int r) {
        return get(1, 0, (this->n) - 1, l, r);
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (tl > tr || r < l) {
            return 0;
        } else if (tl >= l && tr <= r) {
            return t[v];
        }

        int tm = tl + (tr - tl) / 2;
        return get(v * 2, tl, tm, l, min(r, tm)) + get(v * 2 + 1, tm + 1, tr, max(l, tm), r);
    }
};
/*
void solve_j(){
    int n,m;
    cin>>n>>m;
    vector<pair<int,int>> g;
    map<int, unordered_set<int>> gg;
    int u,v;
    for(int _ = 0;_<m;_++){
        cin>>u>>v;
        g.push_back({u,v});
        gg[u].insert(v);
    }
    graph = gg;
    vector<>
    for (int i = 0; i < n; ++i) {
        for (auto )
    }
}
 */
void solve_i(){
    int n;
    cin>>n;
    vector<int> h(n);
    vector<int> p(n);
    for(int i = 0;i<n;i++){
        cin>>h[i];
    }
    for(int i = 0;i<n;i++){
        cin>>p[i];
    }
    vector<pair<int, int>> difference(n);
    for(int i = 0; i < h.size(); i++){
        difference[i] = make_pair(p[i], h[i]);
    }
    sort(difference.begin(), difference.end());

    int result = 0;
    int buff = 0;
    for(int i = 0; i < difference.size(); i++){
        if (i < difference.size() - 1 && difference[i].second > difference[i + 1].second){
            cout << -1 << '\n';
            return;
        }
        if (difference[i].first - buff < difference[i].second){
            cout << -1 << '\n';
            return;
        }
        buff += difference[i].first - buff - difference[i].second;
    }
    cout << buff << '\n';
    return;

}

signed main() {

//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);

    int test = 1;
    cin >> test;
    while (test--) {
        solve_i();
    }

    return 0;
}
