﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Threading;
using System.Diagnostics;
using System.Numerics;
using System.IO;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;
using System.Globalization;
using System.Drawing;

namespace icpc
{
    class Program
    {
        static void Main(string[] args)
        {
            int t = int.Parse(Console.ReadLine());
            for (int i = 0; i < t; i++)
            {
                Test();
            }
        }

        private static void Test()
        {
            int n = int.Parse(Console.ReadLine());
            int[] h = Array.ConvertAll(Console.ReadLine().Split(), int.Parse);
            int[] p = Array.ConvertAll(Console.ReadLine().Split(), int.Parse);
            List<(int, int, int)> ps = p.Zip(h, (x, y) => (x, y)).Select(t => (t.Item1 - t.Item2, t.Item1, t.Item2)).ToList();
            ps.Sort();
            int max = ps[0].Item1;
            for (int i = 1; i < ps.Count; i++)
            {
                if (ps[i].Item2 < ps[i - 1].Item2 ||
                    ps[i].Item3 < ps[i - 1].Item3)
                {
                    Console.WriteLine(-1);
                    return;
                }
                max = Math.Max(max, ps[i].Item1);
            }
            Console.WriteLine(max);
        }
    }
}
