﻿#include <iostream>
#include <vector>
#include <string>
#include <math.h>

using namespace std;

int get_int_mm(string Time);
int get_int_h(string Time);
char* get_mm(char Time[]);
//char* get_h(char Time[]);
int get_minutes(char Time[]);

int main()
{
    int n, minDiff = 0, minDiffInitIndex = 0;
    bool isDone = false;
    vector<int> alarm_times;
    cin >> n;

    char Time[4];
    for (int i = 0; i < n; ++i)
    {
        cin >> Time;
        alarm_times.push_back(get_minutes(Time));
        //cout << "Debug: " << get_minutes(Time) << endl;
    }

    for (int i = 0; i < n - 2; ++i)
    {
        int currDiff = alarm_times[i + 2] - alarm_times[i];
        //cout << "Debug currDiff: " << currDiff << endl;

        if (currDiff <= 10) {
            isDone = true;
            break;
        }

        if (minDiff > currDiff) {
            //cout << "Debug minDiff: " << minDiff << endl;
            minDiffInitIndex = i;
            minDiff = currDiff;
        }
    }

    if (!isDone) {
        int diff1, diff2;
        diff1 = alarm_times[minDiffInitIndex + 1] - alarm_times[minDiffInitIndex];
        diff2 = alarm_times[minDiffInitIndex + 2] - alarm_times[minDiffInitIndex + 1];
        //cout << "Debug diff1: " << diff1 << endl;
        //cout << "Debug diff2: " << diff2 << endl;
        int totalDiff = min(diff1, diff2);
        int totalAlarmN;

        if (totalDiff > 20) { totalAlarmN = 2; }
        else { totalAlarmN = 1; }

        cout << totalAlarmN;
    }
    else {
        cout << 0;
    }

    return 0;
}

int get_int_mm(string Time)
{
    return (Time[2] - 48) * 10 + (Time[3] - 48);
}

int get_int_h(string Time)
{
    return Time[0] - 48;
}

char* get_mm(char Time[])
{
    char answer[2] = { Time[2], Time[3] };
    return answer;
}

/*char* get_h(char Time[])
{
    return Time[0];
}*/
int get_minutes(char Time[])
{
    return get_int_mm(Time) + (get_int_h(Time) - 7) * 60;
}
