﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <unordered_map>

#define ll long long;
#define all(x) (x).begin(), (x).end()

using namespace std;
vector<char> used;
vector<vector<int>> edge;
vector<vector<int>> redge;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	int t; cin >> t;
	while (t--) {
		int n, m; cin >> n >> m;
		edge.resize(n);
		redge.resize(n);
		used.assign(n, 0);
		vector<int> ans(n, 0);
		for (int i = 0; i < m; i++) {
			int u, v; cin >> u >> v;
			u--; v--;
			edge[u].push_back(v);
			redge[v].push_back(u);
			ans[u] += 1;
			//cout << "!!!" << u << ' ' << ans[u] << '\n';
		}

		queue<int> q;
		int mx_i = 0;
		for (int i = 0; i < n; i++) {
			if (ans[i] > ans[mx_i]) {
				mx_i = i;
			}
		}

		//cout << "!!!!" << mx_i << ' ' << ans[mx_i] << '\n';

		for (int i = 0; i < n; i++) {
			//cout << ans[i] << ' ';
			if (ans[mx_i] == ans[i]) {
				q.push(i);
				used[i] = 1;
				//cout << i << ' ';
			}
		}

		//cout << '\n';

		vector<int> retval;
		while (!q.empty()) {
			int v = q.front();
			q.pop();
			retval.push_back(v);
			for (auto u : edge[v]) {
				if (!used[u]) {
					q.push(u);
					used[u] = 1;
				}
			}
		}

		for (int i = 0; i < n; i++) {
			if (!used[i]) {
				retval.push_back(i);
			}
		}

		vector<int> to(n);
		for (int i = 0; i < n; i++) {
			to[retval[i]] = i;
			//cout << retval[i] << ' ' << to[retval[i]] << '\n';
		}

		int cnt = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < edge[i].size(); j++) {
				if (to[i] < to[edge[i][j]]) {
					cnt++;
				}
			}
		}

		if (cnt >= (m + 1) / 2) {
			for (auto& i : retval) {
				cout << i + 1 << ' ';
			}
			cout << '\n';
		}
		else {
			cout << "-1\n";
		}
		//sort(all(ans));
		//reverse(all(ans));
		//for (int i = 0; i < n; i++) {
			//cout << ans[i].second + 1 << " ";
		//}
		//cout << "\n";
	}
}
