for _ in range(int(input())):
    n, m = map(int, input().split())
    adjacent_to = [[] for i in range(n+1)]
    adjacent_from = [[] for i in range(n+1)]
    # to, from
    counts = [[0, 0] for i in range(n+1)]
    used = [0]*(n+1)

    for i in range(m):
        a, b = map(int, input().split())
        a -= 1
        b -= 1
        adjacent_to[b].append(a)
        adjacent_from[a].append(b)
        counts[b][1] += 1
        counts[a][0] += 1

    count_deleted = 0

    result = []
    while True:
        start_nodes = []
        start_node = -1
        min_count = 1e9
        for i in range(n):
            if used[i]:
                continue
            if counts[i][0] - counts[i][1] < min_count:
                min_count = counts[i][0] - counts[i][1]
                start_node = i
            if counts[i][0] == 0:
                start_nodes.append(i)

        if start_node == -1 and len(start_nodes) == 0:
            break

        if len(start_nodes) == 0:
            start_nodes.append(start_node)

        for start_node in start_nodes:
            result.append(start_node)
            used[start_node] = 1
            for node_to in adjacent_to[start_node]:
                counts[node_to][0] -= 1
                adjacent_from[node_to].pop(adjacent_from[node_to].index(start_node))
            for node_from in adjacent_from[start_node]:
                counts[node_from][1] -= 1
                count_deleted += 1
                adjacent_to[node_from].pop(adjacent_to[node_from].index(start_node))

    if (count_deleted > m // 2):
        print(-1)
    else:
        print(*result)



'''
1
3 3
1 2
2 3
3 1

2
3 3
1 2
2 3
3 1
5 6
4 2
2 1
4 3
1 4
3 2
3 5
'''
