#include <iostream>
#include <vector>

struct circle {
    long long x;
    long long y;
    long long r;
};


int main() {
    std::cin.tie(0);
    std::ios_base::sync_with_stdio(0);
    int t = 0;
    std::cin >> t;
    for (int i = 0; i < t; ++i) {
        int n = 0;
        std::cin >> n;
        unsigned long long res = 0;
        std::vector<circle> arr(n);
        for (int j = 0; j < n; ++j) {
            int x, y, r;
            std::cin >> x >> y >> r;
            arr[j] = {x, y, r };
        }
        for (int k = 0; k < n - 1; ++k) {
           auto curr_x = arr[k].x;
           auto curr_y = arr[k].y;
           auto curr_r = arr[k].r;
           for (int j = k + 1; j < n; ++j) {
               unsigned long long center_dist = (arr[j].x - curr_x) * (arr[j].x - curr_x) + (arr[j].y - curr_y) * (arr[j].y - curr_y);
               if (center_dist == (curr_r + arr[j].r) * (curr_r + arr[j].r)) {
                   ++res;
               }
           }
        }
        std::cout << res << std::endl;
    }
    return 0;
}