#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include<bitset>
#include<cassert>
#include<random>

#define int long long
#define sigma signed
//#define double long double

using namespace std;

mt19937_64 rnd(87086040);

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> g(n + 5);
    vector<int> rg(n + 5);

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v; --u; --v;

        g[u].push_back(v);
        rg[v]++;
    }

    set<pair<int, int>> a;

    for (int i = 0; i < n; ++i) {
        a.insert({ rg[i], i });
    }

    int answer = 0;

    vector<int> ans;

    set<int> del;

    while (a.size()) {
        pair<int, int> v = *a.begin();
        a.erase(a.begin());

        del.insert(v.second);
        answer += rg[v.second];
        ans.push_back(v.second);

        for (auto now : g[v.second]) {
            if (del.count(now)) continue;
            a.erase({rg[now], now});

            rg[now]--;

            a.insert({rg[now], now});
        }
    }

    answer = m - answer;

    if (answer >= (m + 1) / 2) {
        for (auto now : ans) cout << now + 1 << ' '; cout << '\n';
    }
    else {
        cout << -1 << '\n';
    }
}

sigma main()
{
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // ONLINE_JUDGE

    int t = 1;
    cin >> t;

#ifdef LOCAL
    auto start = clock();
#endif // ONLINE_JUDGE
    while (t-- > 0) {
            solve();
    }
#ifdef LOCAL
    auto end = clock();

    cout << "\nWorking time: " << end - start << '\n';
    cout << "\nHUI\n";
#endif
}
