#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include<bitset>
#include<cassert>
#include<random>

#define int long long
#define sigma signed
//#define double long double

using namespace std;

mt19937_64 rnd(87086040);

void solve() {
    int n, e;
    cin >> n >> e;

    vector<vector<int>> cnt(n, vector<int>(e, 0));

    set<char> can;

    for (char i = 'a'; i < 'a' + e; ++i) {
        can.insert(i);
    }

    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;

        bool flag = true;

        for (int j = 1; j < s.size(); ++j) {
            if (s[j] != s[j - 1]) {
                flag = false;
            }
        }
        
        if (flag) {
            can.erase(s[0]);
        }
        else {
            for (char j = 'a'; j < 'a' + e; ++j) {
                for (int u = 0; u < s.size(); ++u) {
                    if (s[u] != j) {
                        cnt[i][j - 'a'] = u;

                        break;
                    }
                }
            }
        }
    }

    string answer = "";

    for (auto now : can) {
        int help = 1;

        for (int i = 0; i < n; ++i) {
            help += cnt[i][now - 'a'];
        }

        if (answer.empty() || answer.size() > help) {
            answer.clear();

            for (int i = 0; i < help; ++i) {
                answer += now;
            }
        }
    }

    if (answer.empty()) {
        cout << "NO\n";
    }
    else {
        cout << answer;
    }
}

sigma main()
{
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // ONLINE_JUDGE

    int t = 1;
    //cin >> t;

#ifdef LOCAL
    auto start = clock();
#endif // ONLINE_JUDGE
    while (t-- > 0) {
        solve();
    }
#ifdef LOCAL
    auto end = clock();

    cout << "\nWorking time: " << end - start << '\n';
    cout << "\nHUI\n";
#endif
}
