from sys import stdin, stdout

input = lambda: stdin.readline().strip()
print = lambda *x, sep=' ', end='\n': stdout.write(sep.join(map(str, x)) + end)


def f(a):
    p = sum(a) % 2
    ans = []

    for i in range(len(a)):
        if p == 0:
            ans.append(a[i])
        else:
            ans.append(2 - a[i])
        p = (p - a[i]) % 2

    return ans


def g(a, mod):
    pw = 1
    ans = 0

    for i in range(len(a)):
        ans += a[i] * pw
        pw = (pw * 3) % mod
        ans %= mod

    return ans


def main():
    n = int(input())
    a = [int(x) - 1 for x in input().split()]
    b = [int(x) - 1 for x in input().split()]

    an = f(a)
    bn = f(b)

    if an[::-1] > bn[::-1]:
        an, bn = bn.copy(), an.copy()

    print((g(bn, 998244353) - g(an, 998244353)) % 998244353)


if __name__ == '__main__':
    for _ in range(int(input())):
        main()
