#include <iostream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <array>
#include <iomanip>
#include <unordered_map>
#include <utility>
#include <unordered_set>
#include <bitset>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>
#define sz(_a) ((int)(_a).size())

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> par;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#ifdef MAKS
#define deb(a) #a << '\t' << a << '\t'
#else
#define deb(a) ""
#endif // MAKS



template <typename K, typename L>
std::ostream& operator<<(std::ostream& os, const pair<K, L>& p) {
#ifdef MAKS
    os << '(';
#endif // MAKS
    os << p.first << ' ' << p.second;
#ifdef MAKS
    os << ')';
#endif // MAKS
    return os;
}

template <template <class, class...> class C, typename K, typename... Args,
    typename std::enable_if<!std::is_same<K, char>::value>::type* = nullptr>
std::ostream& operator<<(std::ostream& os, const C<K, Args...>& a) {
#ifdef MAKS
    if (!sz(a)) {
        os << 'E';
    }
#endif // MAKS
    for (const auto& i : a) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}






















const int LET = 26;
array<int, LET> cnt;
vector<string> s;
bitset<LET> bs;
array<int, LET> cnt_ans;

inline signed solve() {

    int n, e;
    cin >> n >> e;
    s.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        int c0 = s[i][0] - 'a';
        ++cnt[c0];
        for (int j = 0; j < sz(s[i]); ++j) {
            int c = s[i][j] - 'a';
            if (c != c0) {
                cnt_ans[c0] += j;
                break;
            }
            if (j + 1 == sz(s[i])) {
                cerr << c0 << '\n';
                bs.set(c0);
            }
        }
    }
    // cerr << bs << '\n';
    int cnt_bs = 0;
    for (int i = 0; i < e; ++i) {
        if (!cnt[i]) {
            cout << char(i + 'a') << '\n';
            return 0;
        }
        cnt_bs += bs[i];
    }
    if (cnt_bs == e) {
        return cout << "NO\n", 0;
    }
    int mn = INT_MAX;
    int ind = 0;
    for (int i = 0; i < e; ++i) {
        if (bs[i]) {
            continue;
        }
        if (mn > cnt_ans[i]) {
            mn = cnt_ans[i];
            ind = i;
        }
        // cout << i << ' ' << cnt_ans[i] << '\n';
    }
    cout << string(mn + 1, char(ind + 'a')) << '\n';
    return 0;

    for (int i = 0; i < n; ++i) {
        int f = s[i][0] - 'a';
        if (!bs[f]) {
            // cerr << f << ' ' << cnt[f] << ' ' << s[i][0] << s[i][1] << '\n';
            if (cnt[f] == 1 && s[i][1] != s[i][0]) {
                return cout << s[i][0] << s[i][0] << '\n', 0;
            }
        }
    }

    cout << "???\n";



    return 0;
}


signed main() {
#ifdef MAKS
    double start = clock();
    freopen("in.txt", "r", stdin);
#endif // MAKS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(11);
    cerr << fixed << setprecision(3);

    int t_t = 1;
    // cin >> t_t;

    while (t_t--) {
        solve();
    }

#ifdef MAKS
    cerr << "\nTime: " << (clock() - start) * 1000.0 / CLOCKS_PER_SEC << "ms\n";
#endif // MAKS
    return 0;
}
