﻿#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>

using ll = long long;
using db = double;
const int inf = 10000000009;
using namespace std;


/*
const int maxn = 10e6;
bool visited[maxn];
vector<int> ans;


void dfs(int v, vector<vector<int>> g) {
    for (auto u : g[v]) {
        if (!visited[u]) {
            visited[u] = true;
            dfs(u, g);
        }
    }
    ans.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n, vector<int>());
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
    }
    for (int v = 0; v < n; v++) {
        if (!visited[v]) {
            dfs(v, g);
        }
    }
    for (auto u : ans) {
        cout << u << " ";
    }
}
*/
const int k = 11111;

int get_max_l(char letter, int e, vector<string>& ls) {
    vector <int> letter_ind(ls.size());
    for (int i = 0; i < k; i++) {
        bool flag = 1;
        for (int j = 0; j < ls.size(); j++) {
            if (ls[j][letter_ind[j]] == letter) {
                letter_ind[j] = (letter_ind[j] + 1) % (int)ls[j].size();
                flag = 0;
            }
        }
        if (flag) {
            return i;
        }
    }
    return -1;
}

void solve() {
    int n, e;
    cin >> n >> e;
    vector<string> ls(n);
    for (int i = 0; i < n; i++) {
        cin >> ls[i];
    }
    int min_ind = 100000;
    char letter = ' ';
    for (int i = 0; i < e; i++) {
        int ind = get_max_l('a' + i, e, ls);
        if (ind < min_ind && ind != -1) {
            min_ind = ind;
            letter = 'a' + i;
        }
    }
    if (letter == ' ') {
        cout << "NO" << endl;
        return;
    }
    string res = "";
    for (int i = 0; i < min_ind + 1; i++) {
        res += letter;
    }
    cout << res << endl;  
}



int main(){

#ifdef DEBUG
    auto f = freopen("test.txt", "r", stdin);
    cout << "Debug Mode" << endl;
#endif // DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    solve();
    
}


