import sys


input = lambda: sys.stdin.readline().strip()
# print = lambda x: sys.stdout.write(x + '\n')


read_ints = lambda: map(int, input().split())


def get_next(i, n):
    return i + 1 if i != n - 1 else 0


def get_prev(i, n):
    return i - 1 if i != 0 else n - 1


def check(diff_arr, zero_pos):
    n = len(diff_arr)
    for i in range(n):
        cur = (zero_pos + i + 1) % n
        next = (zero_pos + i + 2) % n
        diff_arr[next] -= 2 * diff_arr[cur]
        diff_arr[cur] = 0
        if diff_arr[next] < 0:
            return False
    return True


# def check(diff_arr, zero_pos):
#     n = len(diff_arr)
#     for i in range(zero_pos + 1, n):
#         next = get_next(i, n)
#         diff_arr[next] -= 2 * diff_arr[i]
#         if diff_arr[next] < 0:
#             return False
#     for i in range(0, zero_pos - 1):
#         diff_arr[i + 1] -= 2 * diff_arr[i]
#         if diff_arr[i + 1] < 0:
#             return False
#     if zero_pos == 0:
#         return diff_arr[-1] == 0
#     return diff_arr[zero_pos - 1] == 0


def solve_0(n, a):
    mn = min(a)
    mn_pos = a.index(mn)
    if (sum(a) - n * mn) % 3 != 0:
        return False
    d = [0] * n
    for i in range(n):
        d[i] = a[i] - mn

    return check(d, mn_pos)


def solve_1(n, a):
    mn = min(a)
    if mn == 0:
        return False
    mn_pos = a.index(mn)
    if (sum(a) - n * (mn - 1)) % 3 != 0:
        return False
    d = [0] * n
    for i in range(n):
        d[i] = a[i] - mn + 1

    d[mn_pos] = 0
    next = (mn_pos + 1) % n
    d[next] -= 2
    if d[next] < 0:
        return False

    return check(d, mn_pos)


def solve_22(n, a):
    mn = min(a)
    if mn <= 1:
        return False
    mn_pos = a.index(mn)
    if (sum(a) - n * (mn - 2)) % 3 != 0:
        return False
    d = [0] * n
    for i in range(n):
        d[i] = a[i] - mn + 2

    d[mn_pos] = 0
    prev = (mn_pos - 1 + n) % n
    d[prev] -= 1
    if d[prev] < 0:
        return False

    return check(d, mn_pos)


def solve_21(n, a):
    mn = min(a)
    if mn <= 1:
        return False
    mn_pos = a.index(mn)
    if (sum(a) - n * (mn - 2)) % 3 != 0:
        return False
    d = [0] * n
    for i in range(n):
        d[i] = a[i] - mn + 2

    d[mn_pos] = 0
    next = (mn_pos + 1) % n
    d[next] -= 4
    if d[next] < 0:
        return False

    return check(d, mn_pos)


def solve():
    n = int(input())
    a = list(read_ints())
    mn = min(a)
    res = 0
    if solve_0(n, a):
        res = mn
    elif solve_1(n, a):
        res = mn - 1
    elif mn > 1:
        if solve_22(n, a) or solve_21(n, a):
            res = mn - 2

    print(res)




t = 1
t = int(input())
for _ in range(t):
    solve()
