﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <cmath>
#include <cstdlib>
#include <numeric>
#include <chrono>
#include <climits>

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> vec(n);
    for (ll i = 0; i < n; i++)
    {
        cin >> vec[i].first;
    }
    for (ll i = 0; i < n; i++)
    {
        cin >> vec[i].second;
    }
    sort(vec.begin(), vec.end());
    ll a = -1;
    for (ll i = 0, tmp; i < n; i++)
    {
        tmp = vec[i].second - vec[i].first;
        if (tmp < 0 || tmp < a) {
            cout << -1 << "\n";
            return;
        }
        a = max(a, tmp);
    }
    cout << a << "\n";
}

void multitest() {
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

void preCalc() {

}

void fastIO() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
#ifdef _DEBUG
    freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
#endif
    fastIO();
#ifdef _DEBUG
    auto start = chrono::system_clock().now();
#endif
    preCalc();
    multitest();
#ifdef _DEBUG
    auto end = chrono::system_clock().now();
    cout << "\n" << (end - start).count() / 1e7 << " seconds\n";
#endif
}
