﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <cmath>
#include <cstdlib>
#include <numeric>
#include <chrono>
#include <climits>

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
    ll n, e;
    cin >> n >> e;
    set<char> superalpha;
    vector<string> vec;
    string s;
    for (ll i = 0, flag; i < n; i++)
    {
        cin >> s;
        flag = 1;
        for (ll j = 1; j < s.size(); j++)
        {
            if (s[j] != s[0]) {
                flag = 0;
                break;
            }
        }
        if (flag == 1) {
            superalpha.insert(s[0]);
        }
        else {
            vec.push_back(s);
        }
    }
    if (superalpha.size() == e) {
        cout << "NO\n";
        return;
    }
    ll ans_cnt = LLONG_MAX;
    char ans_c = 0;
    char limit = 'a' + e;
    for (char c = 'a', cnt; c < limit; c++)
    {
        if (superalpha.count(c)) {
            continue;
        }
        cnt = 1;
        for (ll i = 0; i < vec.size(); i++)
        {
            for (ll j = 0; j < vec[i].size(); j++)
            {
                if (vec[i][j] != c) {
                    break;
                }
                cnt++;
            }
        }
        if (ans_cnt > cnt) {
            ans_cnt = cnt;
            ans_c = c;
        }
    }
    for (ll i = 0; i < ans_cnt; i++)
    {
        cout << ans_c;
    }
    cout << "\n";
}

void multitest() {
    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}

void preCalc() {

}

void fastIO() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
#ifdef _DEBUG
    freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
#endif
    fastIO();
#ifdef _DEBUG
    auto start = chrono::system_clock().now();
#endif
    preCalc();
    multitest();
#ifdef _DEBUG
    auto end = chrono::system_clock().now();
    cout << "\n" << (end - start).count() / 1e7 << " seconds\n";
#endif
}