﻿//#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <stack>
#include <random>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <climits>
#include <tuple>


using namespace std;
using ll = long long;
using db = double;
using ldb = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vll = vector<ll>;
using vvll = vector<vector<ll>>;
using vint = vector<int>;
using vst = vector<string>;
#define all(x) x.begin(), x.end()
#define size(x) int(x.size())
#define forp(i,s,f) for(int i = s; i < f; ++i)
#define form(i,s,f) for(int i = s; i > f; --i)
#define dprint(x) for(auto now: x) cout << now << ' '

const int MOD = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int MOD3 = 998244353;
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;
const double EPS = 1e-9;
const double PI = acosl(-1.0);

int n, m;
vector<set<int>> In, Out;


void solve() {
    Out.clear();
    In.clear();
    cin >> n >> m;
    In.resize(n + 1);
    Out.resize(n + 1);
    forp(i, 0, m) {
        int u, v;
        cin >> u >> v;
        In[v].insert(u);
        Out[u].insert(v);
    }
    set<pii> st;
    forp(i, 1, n + 1) {
        st.insert({ size(Out[i]) - size(In[i]), i });
    }
    vint ans;
    while (!st.empty()) {
        pii now = *st.rbegin();
        if (now.first < 0) break;
        st.erase(now);
        for (auto next : In[now.second]) {
            st.erase({ size(Out[next]) - size(In[next]), next });
            Out[next].erase(now.second);
            st.insert({ size(Out[next]) - size(In[next]), next });
        }
        for (auto next : Out[now.second]) {
            st.erase({ size(Out[next]) - size(In[next]), next });
            In[next].erase(now.second);
            st.insert({ size(Out[next]) - size(In[next]), next });
        }
        ans.push_back(now.second);
    }
    if (st.empty()) {
        dprint(ans);
        cout << '\n';
    }
    else {
        cout << "-1\n";
    }

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(x);
    cout << fixed;
    int t;
    //t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
