﻿// quarte.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

#define ll long long
#define all(x) x.begin(), x.end()
using namespace std;

ll minValue;

void dfs(int v, vector<bool>& used, vector<ll>& ans, vector<vector<ll>>& g)
{
	used[v] = true;
	for (int i = 0; i < g[v].size(); i++)
	{
		ll to = g[v][i];

		if (!used[to]) {
			dfs(to, used, ans, g);
		}
	}
	ans.push_back(v);
}

int main()
{
	int t;
	cin >> t;
	while (t--)
	{
		minValue = 0;
		ll n, m;
		cin >> n >> m;
		vector<vector<ll>> g(n, vector<ll>());

		for (int i = 0; i < m; i++)
		{
			ll u, v;
			cin >> u >> v;
			u--; v --;
			g[u].push_back(v);
		}
		vector<bool> used(n);

		vector<ll> ans;

		for (int i = 0; i < n; i++)
		{
			if (!used[i])
				dfs(i, used, ans, g);
		}

		reverse(all(ans));

		map<ll, ll> ans_mp;

		for (int i = 0; i < n; i++)
		{
			ans_mp[ans[i]] = n - i;
		}

		for (int i = 0; i < n; i++)
		{
			cout << ans_mp[i] << " ";
		}

		cout << endl;
	}
}