#include <bits/stdc++.h>

#define F first
#define S second


using ld = long double;
using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;

using namespace std;

pair<int, int> e[200010];
vector<int> g[100010];
vector<int> order;
vector<bool> u;

void dfs(int v) {
    u[v] = 1;
    for (auto to: g[v]) {
        if (!u[to]) {
            dfs(to);
        }
    }
    order.push_back(v);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        int m, n;
        cin >> n >> m;
        u.assign(n, 0);
        order.clear();
        for (int i = 0; i < n; ++i) {
            g[i].clear();
        }
        for (int i = 0; i < m; ++i) {
            cin >> e[i].F >> e[i].S;
            --e[i].F, --e[i].S;
            g[e[i].F].push_back(e[i].S);
        }
        for (int i = 0; i < n; ++i) {
            if (!u[i]) {
                dfs(i);
            }
        }
        reverse(order.begin(), order.end());
        // for (auto v: order) {
        //     cerr << v + 1 << ' ';
        // }
        // cerr << '\n';
        unordered_map<int, int> mp;
        for (int i = 0; i < order.size(); ++i) {
            mp[order[i]] = i;
        }
        int cnt = 0;
        for (int i = 0; i < m; ++i) {
            if (mp[e[i].F] < mp[e[i].S]) {
                ++cnt;
            }
        }
        reverse(order.begin(), order.end());
        mp.clear();
        cnt = 0;
        for (int i = 0; i < order.size(); ++i) {
            mp[order[i]] = i;
        }
        for (int i = 0; i < m; ++i) {
            if (mp[e[i].F] < mp[e[i].S]) {
                ++cnt;
            }
        }
        if (cnt >= (m + 1) / 2) {
            for (auto v: order) {
                cout << v + 1 << ' ';
            }
            cout << '\n';
            continue;
        } else {
            cout << -1 << '\n';
        }
    }
}
