﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>

#define ll long long
#define vll vector<long long>
#define REP(i, s, n) for (size_t i = s; i < n; ++i)
#define VIN(v) for (auto &i : v) { cin >> i; }
using namespace std;


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, e;
    cin >> n >> e;
    vector<int> a(e, 0);

    string inp;
    for (int i = 0; i < n; i++) {
        cin >> inp;

        char c = inp[0];

        if (a[(int)(c - 'a')] != -1) {
            int j = 1;
            while (j < inp.length() && inp[j] == inp[j - 1]) j++;

            if (j == inp.length()) {
                a[(int)(c - 'a')] = -1;
                continue;
            }

            a[(int)(c - 'a')] += j;
        }
    }

    int min_i = -1;
    int min_e = 1e9;

    for (int i = 0; i < e; i++) {
        if (a[i] >= 0 && a[i] < min_e) {
            min_i = i;
            min_e = a[i];
        }
    }

    if (min_i == -1) {
        cout << "NO";
        return 0;
    }
    char res = (char)(min_i + 'a');
    for (int i = 0; i < min_e + 1; i++) {
        cout << res;
    }
}