﻿#include <iostream>
#include <set>
#include <queue>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <string>
#include <vector>
#include <iomanip>
#include <map>

using namespace std;

int countt = 1;

void dfs(vector<vector<int>>& a, int start, vector<int>& used, vector<int>& news) {

	if (used[start] == 0) {
		used[start] = 1;
		for (int i = 0; i < a[start].size(); i++) {
			if (used[a[start][i]] != 1) {
				news[a[start][i]] = countt++;
				//news.push_back(a[start][i] + 1);
				dfs(a, a[start][i], used, news);
			}
		}
	}
}

bool cmp(vector <int> a, vector <int> b) {
	if (a[0] < b[0])
		return true;
	if (a[0] > b[0])
		return false;
	if (a[1] > b[1])
		return true;
	if (a[1] < b[1])
		return false;
	if (a[2] < b[2])
		return true;
	else
		return false;
}

int main()
{
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector < vector <int> > a(n);
		set < vector <int> > s;
		map <int, int> in, out;
		for (int i = 0; i < m; ++i) {
			int x, y;
			cin >> x >> y;
			a[x - 1].push_back(y - 1);
			in[y - 1]++;
			out[x - 1]++;
		}
		vector < vector <int> > arr;
		for (int i = 0; i < n; ++i) {
			//s.insert({ in[i], out[i], i });
			arr.push_back({ in[i], out[i], i });
		}
		sort(arr.begin(), arr.end(), cmp);
		int start = arr[0][2];
		/*
		int start = (*s.begin())[2];
		int start_firstf = (*s.begin())[0];
		auto it = s.begin()++;
		while ((*it)[0] == start_firstf ) {
			start = (*it)[2];
			it++;
			if (it == s.end())
				break;
		}
		*/
		vector<int> used(n, 0);
		vector<int> news(n, 0);
		countt = 1;
		dfs(a, start, used, news);
		

		int amount = 0;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < a[i].size(); ++j) {
				if (news[i] < news[a[i][j]])
					amount++;
			}
		if (amount < m / 2)
			cout << -1 << "\n";
		else {
			for (int i = 0; i < n; i++)
				cout << news[i] + 1 << ' ';
			cout << '\n';
		}
	}
}