﻿#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <deque>
#include <stack>
#include <list>
#include <bitset>
#include <string>

#define num long long

using namespace std;

void solution() {
	num n;
	cin >> n;
	vector<num> points;

	for (num i = 0; i < n; i++) {
		string str;
		cin >> str;
	
		num point = (num)(str[0] - '0') * 60 + (num)(str[2] - '0') * 10 + (num)(str[3] - '0');
		points.push_back(point);
	}
		num maxTotal = 1;
		for (num i = 0; i < n; i++) {
			num nowTotal = 1;
			for (num j = i + 1; j < n; j++) {
				if (points[j] <= points[i] + 10) {
					nowTotal += 1;
				}
				maxTotal = max(maxTotal, nowTotal);
			}
		}

	
	cout << max((num)0, 3 - maxTotal) << "\n";
}

num search(num x, vector<num> nums) {
	num left = 0; num right = nums.size();
	num mid = (left + right) / 2;
	while (left + 1 < right) {
		if (nums[mid] <= x) {
			left = mid;
		}
		else {
			right = mid;
		}
	}
	return left;

}
 
int main() {
	ios_base::sync_with_stdio(false);
	num n = 1;
	while (n--) {
		solution();
	}

	return 0;
}
